function  dpr3 = PLM_dprime3(Mdata)

%PLM_DPRIME3 -- Run PLMODEL1 and calculate d-primes for the 3 contrasts.
%
%  dpr3 = PLM_dprime3(Mdata)     is simply equivalent to:
%             Z = PLM_Zcongr1(Mdata) ; 
%             dpr3 = Z([1 3 5],:) + Z([2 4 6],:) ;
%
%  Useful for fitting the model to the three d' curves rather than the
%  six z-probability curves. This bypasses most criterion-related issues.
%
%  See also PLM_ZCONGR1, PLM_PARAMSEARCH, PLM_SUMSQFIT, PLMODEL1.

%  Original coding by Alexander Petrov, UC Irvine.
%  $Revision: 1.0 $  $Date: 2003/04/18 16:09 $

Z = PLM_Zcongr1(Mdata) ; 
dpr3 = Z([1 3 5],:) + Z([2 4 6],:) ;

%-- Return DPRIME3
%%%%% End of file PLM_DPRIME3.M
