function  I = argmin(X)

%ARGMIN -- Index of the minimial element.
%
%  I = ARGMIN(X)   is equivalent to  [_,I] = min(X)
%
%  Example:  
%    argmin([4 5 8 1 6 3  9 2 7 3 6 1])  ==>  4
%    argmin([4 5 8 1 6 3; 9 2 7 3 6 1])  ==>  [1 2 2 1 1 2]
%
%  See also MIN, ARGMAX.

%  Original coding by Alexander Petrov, Ohio State University.
%  $Revision: 1.0 $  $Date: 2004/03/03 09:20 $
%
% Part of the utils toolbox version 1.1 for MATLAB version 5 and up.
% http://alexpetrov.com/softw/utils/
% Copyright (c) Alexander Petrov 1999-2006, http://alexpetrov.com
% Please read the LICENSE and NO WARRANTY statement in ../utils_license.m

[foo,I] = min(X) ;

%%  Return I
%%%%%% End of file ARGMIN.M
